#include "except.h"


extern FILE* dumpPtr;

void catchException(DWORD exception)
{
	switch (exception)
	{
	case EXCEPTION_ACCESS_VIOLATION:
		fprintf(dumpPtr, "The thread attempted to read from or write to a virtual address for which it \
			does not have the appropriate access.\n");
		break;
	case EXCEPTION_BREAKPOINT:
		fprintf(dumpPtr, "A breakpoint was encountered.\n");
		break;
	case EXCEPTION_DATATYPE_MISALIGNMENT:
		fprintf(dumpPtr, "The thread attempted to read or write data that is misaligned on hardware that \
			does not provide alignment. For example, \
			16-bit values must be aligned on 2-byte boundaries, 32-bit values on 4-byte boundaries,\
			and so on.\n");
		break;
	case EXCEPTION_SINGLE_STEP:
		fprintf(dumpPtr, "A trace trap or other single-instruction mechanism signaled that one \
			instruction has been executed.\n");
		break;
	case EXCEPTION_ARRAY_BOUNDS_EXCEEDED:
		fprintf(dumpPtr, "The thread attempted to access an array element that is out of bounds,\
			and the underlying hardware supports bounds checking. \n");
		break;
	case EXCEPTION_FLT_DENORMAL_OPERAND:
		fprintf(dumpPtr, "One of the operands in a floating-point operation is denormal. A denormal \
			value is one that is too small to represent as a standard floating-point value.\n");
		break;
	case EXCEPTION_FLT_DIVIDE_BY_ZERO:
		fprintf(dumpPtr, "The thread attempted to divide a floating-point value by a floating-point \
			divisor of zero. \n");
		break;
	case EXCEPTION_FLT_INEXACT_RESULT:
		fprintf(dumpPtr, "The result of a floating-point operation cannot be represented exactly \
			as a decimal fraction. \n");
		break;
	case EXCEPTION_FLT_INVALID_OPERATION:
		fprintf(dumpPtr, "This exception represents any floating-point exception not included in this list.\n");
		break;
	case EXCEPTION_FLT_OVERFLOW:
		fprintf(dumpPtr, "The exponent of a floating-point operation is greater than the magnitude\
			allowed by the corresponding type. \n");
		break;
	case EXCEPTION_FLT_STACK_CHECK:
		fprintf(dumpPtr, "The stack overflowed or underflowed as the result of a floating-point operation.\n");
		break;
	case EXCEPTION_FLT_UNDERFLOW:
		fprintf(dumpPtr, "The exponent of a floating-point operation is less than the magnitude allowed\
			by the corresponding type. \n");
		break;
	case EXCEPTION_INT_DIVIDE_BY_ZERO:
		fprintf(dumpPtr, "The thread attempted to divide an integer value by an integer divisor of zero.\n");
		break;
	case EXCEPTION_INT_OVERFLOW:
		fprintf(dumpPtr, "The result of an integer operation caused a carry out of the most significant\
			bit of the result. \n");
		break;
	case EXCEPTION_PRIV_INSTRUCTION:
		fprintf(dumpPtr, "The thread attempted to execute an instruction whose operation is not\
			allowed in the current machine mode. \n");
		break;
	case EXCEPTION_NONCONTINUABLE_EXCEPTION:
		fprintf(dumpPtr, "The thread attempted to continue execution after a noncontinuable \
			exception occurred. \n");
		break;
	}
	fclose(dumpPtr);
	dumpPtr=NULL;
}
