#pragma once

#include "config.h"
#include "dataStructure.h"
#include "octreeLoader.h"
#include "renderEngine.h"
#include <mpi.h>
#include <GL/glut.h>


struct RendererContext
{
	static char* windowTitle;
	int myRenderIndex;
	
	
	OctreeLoader octreeLoader;
	RenderEngine renderEngine;

	ubyte* colorBuffer;
	ubyte* pixelDataBuffer;
	ubyte* visibleTable;
	//////////////////////////////////////
	//compressed visible table
	ubyte* compressedVisibleTable;
	/////////////////////////////////////

	MPI_Request* visibleTableRequests;
	MPI_Request* pixelDataRequests;
	MPI_Request naiveVisibleTableRequest;

	void init();

	void displayCallback();

	void readColorBuffer();

	void recvVisiblePixelInfo();
	void testVisiblePixelInfoRecving();

	void testPixelDataSending();
	void sendPixelData();
	void recvNaiveVisiblePixelInfo();

};

static RendererContext rendererContext;
