#ifndef RENDERENGINE_H
#define RENDERENGINE_H
#include "config.h"
#include "octreeLoader.h"

#define PI 3.1415926535897932384626433832795


const double DefaultNearPlane=0.001;
//static int frameCounter=0;
//static int lastFrameCounter=0;
//static unsigned long lastTickCounter=0;

//float pos_x=0.0, pos_y=0.0, pos_z=0.0;

extern void convertPlyFile(char* dirName, bool toExpand, bool toConvert=false);

//void updateDrawingContext();


void createFiles(char* dirName, int expandNumber, bool toConvert=false);
//inline VType deg2rad(VType deg);
//inline VType rad2deg(VType rad);

//const VType AngleOffset=5;
// VType PositionOffset=10.1235;
//const GLfloat PositionOffset=0.01;
//const VType MovementOffset=10.1235;
//const GLfloat MovementOffset=0.01;

//void calcCoord(VType distance, const Movement& position, VType &x, VType &y, VType &z);
//void drawOctree();

//static Movement movement;

//static PlyVertex* vertexArray=NULL;
//static UIVector* faceArray=NULL;
//static PlyModel myPly;

//void simpleInit();
//void simpleDisplay();


//static FVector StartingPos={-0.037830, 0.127940, -0.995525};
//static 

struct DrawingContext
{
	VVector eye;
	VVector center;
	VVector up;	
	VType	fovy;
	VType	aspect;
	VType	zNear;
	VType	zFar;
};

struct Movement
{
	VType x,y,z;
	VType yaw, pitch, roll;
	VType fLook_x, fLook_y, fLook_z;
	VType fUp_x, fUp_y, fUp_z;
	void display();
};


struct Lighting
{
	enum ColorName
	{
		BLACK, RED, GREEN, BLUE, YELLOW, MAGENTA, PINK, WHITE
	};

	int currentLightNumber;//=8;
	bool lightEnabled;//=false;
	void init();
	void toggleLighting();
	void update(const Movement& movement);
};

struct RenderEngine
{
	Movement movement;
	DrawingContext drawingContext;
	Lighting lighting;

	VVector startingPos;//={-100, 25500, 100};
	VType positionOffset;//=10.1235;
	VType angleOffset;//=5;
	VType movementOffset;//=10.1235;
	bool flatShading;//=true;
	bool wireFrame;

	void setupPerspective(OctreeLoader* octreeLoader);
	void updatePosition();

	void initializeMovement(VVector origin);

	void showMenu();
	inline VType deg2rad(VType deg);
	inline VType rad2deg(VType rad);
	void calcCoord(VType distance, const Movement& position, VType &x, VType &y, VType &z);
	//void initLights();

	void init(OctreeLoader* octreeLoader);

	void keyboardCallback(unsigned char key, int x, int y);
	void specialCallback(int key, int x, int y);

};

#endif
