/******************************************************
This module is a wrapper of system call of windows and linux					
***************************************************************/
#pragma once
#define LINUX_VERSION 1
//#define USING_SEPARATE_DISPLAYER 1
//#define USING_SYNCHRONIZATION 1
#define USING_TESTER_RENDER 1
//#define USING_TESTER_OCCLUDER 1
#define USING_COHERENT_NODE 1
#define USING_BINARY_SWAP 1
//#define USING_SNAPSHOT 1
//#define USING_ALL_GATHER 1
#define USING_BINARY_EXCHANGE 1
#define USING_COMPRESSION 1
//#define USING_BROADCAST 1
#define USING_QUICK_RECURSION 1
//#define USING_DUMMY_RENDER 1
//#define USING_NAIVE_DEPTH_BUFFER_EXCHANGE 1
//#define DEBUGGING 1
#ifdef LINUX_VERSION
#define USING_FORCE_REFRESH 1
//this is only meaningful in linux HPMPI
//#define PROFILE_ALL 1
//#define DISPLAY_INFO 1

//#define PROFILING 1
#define PROFILE_CM 1
#define PROFILE_CT 1
#define PROFILE_CR 1
#define PROFILE_CD 1
#define PROFILE_BMTRD 1
#define PROFILE_BTRD 1
#define PROFILE_BRD 1
#define PROFILE_BT 1
#define PROFILE_ALL 1
#endif

#include <stdio.h>
#include <vector>
#ifndef LINUX_VERSION
#include <windows.h>
typedef unsigned __int64 LONGLONG;
#else

typedef unsigned long long LONGLONG;
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#endif


using namespace std;

static int result;

#ifdef LINUX_VERSION
#define HANDLE int

#define MAX_TEMP_NAME_LENGTH L_tmpnam
#define MAX_PATH 256
#define DWORD unsigned long int

//#define LINUX_SYSCALL(x, y) if (x==-1){perror(y); exit(123);}
#define LINUX_SYSCALL(x, y) if (x==-1){perror(y); throw ;}
//#define LINUX_SYSCALL(x, y) if (x==-1){perror(y); }

#define Int32x32To64(a,b) ((long long)((long)(a))*(long long)((long)(b)))
//long int GetTickCount();
#else
#define MAX_TEMP_NAME_LENGTH MAX_PATH


typedef struct 
{
	time_t tv_sec;
	time_t tv_usec;
}timeval;

#define WINAPI_CALL(x, y) if (x==0) {printf("%s: #%d\n", y, GetLastError()); exit(124);}

#endif

long int GenericGetProfileTime();
long int GenericGetTime();

HANDLE GenericOpenFile(char* fileName, bool readOnly);

int GenericWriteFile(HANDLE fileHandle, void* buffer, size_t length);

int GenericReadFile(HANDLE fileHandle, void* buffer, size_t length);


HANDLE GenericOpenTempFile(const char* nameString, char* buf);


void GenericCloseTempFile(HANDLE handle, const char* fileName);

void GenericCloseFile(HANDLE fileHandle);

void GenericSetFilePointer(HANDLE fileHandle, unsigned long int low, unsigned long int high);


HANDLE GenericCreateFileMapping(HANDLE fileHandle, bool readOnly);

void* GenericMapViewOfFile(HANDLE fileMappingHandle, bool readOnly, unsigned long int fileAddHigh, 
	unsigned long int fileAddLow, unsigned int length);


void GenericUnmapViewOfFile(void* address, int length);


void GenericRetrieveAllFile(char* dirName, vector<string>& fileNameVector);

void GenericCloseFileMapping(HANDLE fileMappingHandle);

//HANDLE GenericOpenLog(char* logName);
