#pragma once

#include "config.h"
#include "dataStructure.h"
#include "occluder.h"
#include "octreeLoader.h"
#include "renderEngine.h"
#include <mpi.h>



struct BinarySwapDescriptor
{
	int myTesterIndex;
	int myLeaderIndex;
	int myGroupSize;
	int myBuddyIndex;
	int myTileIndex;
	int myTileCount;
	int mySendIndex;
	int myRecvIndex;
	unsigned int mask;
	
	//bool isLow;
	void init(int testerIndex);
	bool next();	
	void display();
};

struct TesterContext
{
	static char* windowTitle;
	unsigned int myTesterIndex;

	RenderEngine renderEngine;
	OctreeLoader octreeLoader;
	Occluder occluder;
	unsigned int depthBufferCount;
	unsigned int colorBufferCount;
	MPI_Request* depthBufferExchangeRequests;
	MPI_Request* colorBufferExchangeRequests;

	MPI_Comm testerComm;
	MPI_Group testerGroup;
		
	float** depthBuffer;
	ubyte** colorBuffer;
	float* myDepthBuffer;
	float* hisDepthBuffer;
	ubyte* myColorBuffer;
	ubyte* hisColorBuffer;

	BinarySwapDescriptor* binarySwapDescriptor;

	//return the length of compressed run-length
	//int compressVisibleTable(ubyte*source, int tileIndex);
	//void decompressVisibleTable(ubyte*target, int tileIndex, int count);
	/////////////////////////////////
	void init();

	void keyboardCallback(unsigned char key, int x, int y);

	void displayCallback();

	void readColorBuffer();
	void readDepthBuffer();

	void exchangeDepthBuffer();

	void sendColorBuffer();
	void testColorBufferSending();
	void debugPrint(const char* msg);
/////////////////////////////////////
	//a testing method
	void occluderTest();
};

static TesterContext testerContext;






















